<body>
<html>
<?php

function sanitizeMyThings($input)
{
  $output = trim($input);
  $output = filter_var($input, FILTER_SANITIZE_STRING);
  return $output;
}

if (preg_match('/^[\/\w\-. ]+$/', $_POST['rolename'].'.php')){
  echo 'VALID FILENAME';

  $language = $_POST['language'];
  $rolefile = fopen("roles/".$language."/".$_POST['rolename'].".php", "w");


  #Initialisation
  fwrite($rolefile, '<?php'.PHP_EOL);
  #
  # COLORS
  #

  # This is the color defined by https://materializecss.com/color.html
  $f_color = sanitizeMyThings($_POST['rolecolor']." ".$_POST['rolemod']."-".$_POST['rolestrength']);
  fwrite($rolefile, '$color = "'.$f_color.'";'.PHP_EOL);

  # Text Color
  $f_tcolor = sanitizeMyThings($_POST['tcolor']);
  fwrite($rolefile, '$tcolor = "'.$f_tcolor.'-text";'.PHP_EOL);


  #
  # BASEINFO
  #

  #The Name of the Role
  $f_name = sanitizeMyThings($_POST['rolename']);
  fwrite($rolefile, '$name = "'.$f_name.'";'.PHP_EOL);

  #The Description of the Role, HTML conform :)
  $f_description = sanitizeMyThings($_POST['roledesc']);
  fwrite($rolefile,'$description = "'. $f_description.'";'.PHP_EOL);




  #
  # TABS
  #

  #How To play
  $f_howtoplay = sanitizeMyThings($_POST['howtoplay']);
  fwrite($rolefile, '$howtoplay = "'.sanitizeMyThings($f_howtoplay).'";'.PHP_EOL);

  #With what roles does this role play best?
  fwrite($rolefile, '$playsbestwith = "<ul>;'.PHP_EOL);

    foreach($_POST['goodRoles'] as $selectedOption) {
    fwrite($rolefile, '<li>'.sanitizeMyThings($selectedOption).'</li>'.PHP_EOL);
  };
  fwrite($rolefile, '</ul>";'.PHP_EOL);


  #Convars
  $f_convars = '$convars = "Normal Role Convars (also found in ULX):
  <code>'.sanitizeMyThings($_POST['gconvars']).'</code>

  Rolespecific Convars:
  <code>'.sanitizeMyThings($_POST['cconvars']).'</code>";';

  fwrite($rolefile, $f_convars.PHP_EOL);


  #
  # Credits
  #

  #The Steam URL to your addon
  $f_steam = sanitizeMyThings($_POST['steam']);
  fwrite($rolefile, '$steam = "'.$f_steam.'";'.PHP_EOL);
  #The Source URL to your addon
  $f_source = sanitizeMyThings($_POST['source']);
  fwrite($rolefile, '$source = "'.$f_source.'";'.PHP_EOL);

  #Creator of the Addon
  $f_author = sanitizeMyThings($_POST['creator']);
  fwrite($rolefile, '$author = "'.$f_author.'";'.PHP_EOL);
  #Creatorlink
  $f_authorurl = sanitizeMyThings($_POST['creatorurl']);
  fwrite($rolefile, '$authorurl = "'.$f_authorurl.'";'.PHP_EOL);
  # Credittext (can use the above variables)
  $f_ctext = sanitizeMyThings($_POST['credits']);
  fwrite($rolefile, '$ctext = "'.$f_ctext.'";'.PHP_EOL);

fwrite($rolefile, '?>');
fclose($rolefile);
} else {
    echo 'INVALID ROLENAME';
}
?>

</body>
</html>
